﻿using System.Text;
using System.Text.Json;
namespace VisionTaskExample
{
  public  class visionParams
{
    public int iMaxPos { get; set; }
    public double dMaxOverlap { get; set; }
    public double dScore { get; set; }
    public double dToleranceAngle { get; set; }
    public int iMinReduceArea { get; set; }

    public bool bToleranceRange { get; set; }
    public double dTolerance1 { get; set; }
    public double dTolerance2 { get; set; }
    public double dTolerance3 { get; set; }
    public double dTolerance4 { get; set; }
}
    public class Program {
        static async Task Main(string[] args)
        {
            visionParams parameter = new visionParams
            {
                iMaxPos = 30,
                dMaxOverlap = 0,
                dScore = 0.65,
                dToleranceAngle = 180,
                iMinReduceArea = 256,
                bToleranceRange = false,
                dTolerance1 = -10,
                dTolerance2 = 10,
                dTolerance3 = 170,
                dTolerance4 = 190,
            };

            HttpClient client = new HttpClient();
            try
            {
                var content = new StringContent(JsonSerializer.Serialize(parameter), Encoding.UTF8, "application/json");
                using HttpResponseMessage response = await client.PostAsync("http://127.0.0.1:5005/SetParams",content);
                response.EnsureSuccessStatusCode();
                string responseBody = await response.Content.ReadAsStringAsync();
                Console.WriteLine(responseBody);
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine("\nException Caught!");
                Console.WriteLine("Message :{0} ", e.Message);
            }

            byte[] pattern = System.IO.File.ReadAllBytes(@"template.jpg");
            try
            {
                var content = new StringContent(Convert.ToBase64String(pattern), Encoding.UTF8, "application/json");
                using HttpResponseMessage response = await client.PostAsync("http://127.0.0.1:5005/SetDst", content);
                response.EnsureSuccessStatusCode();
                string responseBody = await response.Content.ReadAsStringAsync();
                Console.WriteLine(responseBody);
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine("\nException Caught!");
                Console.WriteLine("Message :{0} ", e.Message);
            }
            byte[] source = System.IO.File.ReadAllBytes(@"source.jpg");
            try
            {
                var content = new StringContent(Convert.ToBase64String(source), Encoding.UTF8, "application/json");
                using HttpResponseMessage response = await client.PostAsync("http://127.0.0.1:5005/SetSrc", content);
                response.EnsureSuccessStatusCode();
                string responseBody = await response.Content.ReadAsStringAsync();
                string[] strings = responseBody.Split(Environment.NewLine);
                Console.WriteLine("Found " + (strings.Length-1).ToString() + " parts");
                foreach (var item in strings)
                {
                    string[] results = item.Split(";");
                    if (results.Length > 3)
                    {
                        Console.WriteLine("Nr: " + results[0] + ", Score: " + results[1] + ", Angle: " + results[2] + ", X pos: " + results[3] + ", Y pos: " + results[4]);
                    }
                }
            }
            catch (HttpRequestException e)
            {
                Console.WriteLine("\nException Caught!");
                Console.WriteLine("Message :{0} ", e.Message);
            }
        }
}}